unit IBConnectionPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, ExtCtrls,  StdCtrls;

type

  TIBConnectionPanel = class(TPanel)
    rgConnection: TRadioGroup;
    GroupBox1: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    eUserName: TEdit;
    ePassword: TEdit;
    GroupBox2: TGroupBox;
    EserverName: TEdit;
    GroupBox3: TGroupBox;
    FIPType: TComboBox;
    GroupBox4: TGroupBox;
    FDBfile: TEdit;
  private
    procedure rgConnectionClick(Sender: TObject);
    function GetUserName: String;
    function GetPassword: string;
    function GetServerName: string;
    function GetDatabaseName: string;
    function GetIPType: integer;
    function GetServerType: integer;
    procedure SetUserName(Value: string);
    procedure SetPassword(Value: string);
    procedure SetServerName(Value: string);
    procedure SetDataBaseName(Value: string);
    procedure SetServerType(Value: integer);
    procedure SetIPType(Value: integer);
  protected
  public
    procedure Paint; override;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
   property UserName: String read GetUserName write SetUserName;
   property Password: String read GetPassword write SetPassword;
   property ServerName: string read GetServerName write SetServerName;
   property DatabaseName: String read GetDatabaseName write SetDataBaseName;
   property IPType: integer read GetIPType write SetIPType;
   property ServerType: integer read GetServerType write SetServerType;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('DB Connection', [TIBConnectionPanel]);
end;

{ TIBConnectionPanel }

constructor TIBConnectionPanel.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  BevelOuter := bvNone;
  BevelInner := bvNone;
  Align := alClient;
  ParentFont := false;
  ParentColor := false;
  ParentCtl3D := false;
  rgConnection := TRadioGroup.Create(Self);
  rgConnection.Parent := Self;
  rgConnection.Caption := ' Connection ';
  rgConnection.OnClick := rgConnectionClick;
  rgConnection.Left := 8;
  rgConnection.Top := 7;
  rgConnection.Width := 113;
  rgConnection.Height := 66;
  rgConnection.ParentFont := false;
  rgConnection.ParentColor := false;
  rgConnection.ParentCtl3D := false;

  GroupBox2 := TGroupBox.Create(Self);
  GroupBox2.Parent := Self;
  GroupBox2.Caption := ' Server ';
  GroupBox2.Left := 126;
  GroupBox2.Top := 7;
  GroupBox2.Width := 139;
  GroupBox2.Height := 66;

  EserverName := TEdit.Create(GroupBox2);
  EserverName.Parent := GroupBox2;
  EserverName.Left := 12;
  EserverName.Top := 24;
  EserverName.Width := 115;
  EserverName.Height := 21;
  EserverName.Text := '';

  GroupBox3 := TGroupBox.Create(Self);
  GroupBox3.Parent := Self;
  GroupBox3.Caption := ' Protocol ';
  GroupBox3.Left := 270;
  GroupBox3.Top := 7;
  GroupBox3.Width := 121;
  GroupBox3.Height := 66;

  FIPType := TComboBox.Create(GroupBox3);
  FIPType.Parent := GroupBox3;
  FIPType.Left := 16;
  FIPType.Top := 24;
  FIPType.Width := 89;
  FIPType.Height := 21;
  FIPType.Text := '';

  GroupBox4 := TGroupBox.Create(Self);
  GroupBox4.Parent := Self;
  GroupBox4.Caption := ' Data Base ';
  GroupBox4.Left := 8;
  GroupBox4.Top := 80;
  GroupBox4.Width := 259;
  GroupBox4.Height := 53;

  FDBfile := TEdit.Create(GroupBox4);
  FDBfile.Parent := GroupBox4;
  FDBfile.Left := 8;
  FDBfile.Top := 20;
  FDBfile.Width := 234;
  FDBfile.Height := 21;
  FDBfile.Text := '';

  GroupBox1 := TGroupBox.Create(Self);
  GroupBox1.Parent := Self;
  GroupBox1.Caption := ' IB Server authorization ';
  GroupBox1.Left := 8;
  GroupBox1.Top := 136;
  GroupBox1.Width := 177;
  GroupBox1.Height := 89;

  Label3 := TLabel.Create(GroupBox1);
  Label3.Parent := GroupBox1;
  Label3.Left := 8;
  Label3.Top := 25;
  Label3.Caption := 'Login';

  Label4 := TLabel.Create(GroupBox1);
  Label4.Parent := GroupBox1;
  Label4.Left := 8;
  Label4.Top := 57;
  Label4.Caption := 'Password';

  eUserName := TEdit.Create(GroupBox1);
  eUserName.Parent := GroupBox1;
  eUserName.Left := 60;
  eUserName.Top := 23;
  eUserName.Width := 100;
  eUserName.Height := 21;
  eUserName.Text := 'SYSDBA';

  ePassword := TEdit.Create(GroupBox1);
  ePassword.Parent := GroupBox1;
  ePassword.Left := 60;
  ePassword.Top := 54;
  ePassword.Width := 100;
  ePassword.Height := 21;
  ePassword.Text := '';
  ePassword.PasswordChar := '*';

  EserverName.Enabled := false;
  FIPType.Enabled := false;

end;

destructor TIBConnectionPanel.Destroy;
begin
  FDBfile.Free;
  FDBfile := nil;
  ePassword.Free;
  ePassword := nil;
  eUserName.Free;
  eUserName := nil;
  Label4.Free;
  Label4 := nil;
  Label3.Free;
  Label3 := nil;
  GroupBox1.Free;
  GroupBox1 := nil;
  FIPType.Free;
  FIPType := nil;
  GroupBox3.Free;
  GroupBox3 := nil;
  EserverName.Free;
  EserverName := nil;
  GroupBox2.Free;
  GroupBox2 := nil;
  rgConnection.Free;
  rgConnection := nil;
  inherited Destroy;
end;

function TIBConnectionPanel.GetDatabaseName: string;
begin
 Result := FDBfile.Text;
end;

function TIBConnectionPanel.GetIPType: integer;
begin
 Result := FIPType.ItemIndex;
end;

function TIBConnectionPanel.GetPassword: string;
begin
 Result := ePassword.Text;
end;

function TIBConnectionPanel.GetServerName: string;
begin
 Result := EserverName.Text;
end;

function TIBConnectionPanel.GetServerType: integer;
begin
 Result := rgConnection.ItemIndex;
end;

function TIBConnectionPanel.GetUserName: String;
begin
 Result := eUserName.Text;
end;

procedure TIBConnectionPanel.Paint;
begin
  inherited;
  Caption := '';
  if rgConnection.Items.Count = 0 then
   begin
    rgConnection.Items.Add('Local');
    rgConnection.Items.Add('Network');
    rgConnection.ItemIndex := 0;
   end;
  if FIPType.Items.Count = 0 then
   begin
    FIPType.Items.Add('TCP');
    FIPType.Items.Add('NamedPipe');
    FIPType.Items.Add('SPX');
    IPType := 0;
   end;
end;

procedure TIBConnectionPanel.rgConnectionClick(Sender: TObject);
begin
 EserverName.Enabled := rgConnection.ItemIndex = 1;
 FIPType.Enabled := rgConnection.ItemIndex = 1;
end;

procedure TIBConnectionPanel.SetDataBaseName(Value: string);
begin
 FDBfile.Text := Value;
end;

procedure TIBConnectionPanel.SetIPType(Value: integer);
begin
 FIPType.ItemIndex := Value;
end;

procedure TIBConnectionPanel.SetPassword(Value: string);
begin
 ePassword.Text := Value;
end;

procedure TIBConnectionPanel.SetServerName(Value: string);
begin
 EserverName.Text := Value;
end;

procedure TIBConnectionPanel.SetServerType(Value: integer);
begin
  rgConnection.ItemIndex := value;
end;

procedure TIBConnectionPanel.SetUserName(Value: string);
begin
  eUserName.Text := Value;
end;

end.
